> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/android/standalone-modules/document-detector/builder/advanced-settings/proxy-settings.md).

# Proxy configuration

## **How to use** <a href="#emy5d62jzxkv" id="emy5d62jzxkv"></a>

For the SDK to use your proxy to make requests, you must enter the settings to be used through an instance of the **`ProxySettings`** class sent as a parameter to the **`setProxySettings`** method in the builder of any of our SDKs:

```java
ProxySettings proxySettings = new ProxySettings(hostname, port)
    .setAuthentication(user, password); // This call is not mandatory, see documentation below

DeviceAuthenticator mDeviceAuthenticator = new DeviceAuthenticator.Builder(mobileToken)
    .setProxySettings(proxySettings)
    .build();
```

## **Constructor method** <a href="#et2stmlb4kk8" id="et2stmlb4kk8"></a>

<table><thead><tr><th width="213">Parameter</th><th width="137.66666666666666">Type</th><th>Description</th></tr></thead><tbody><tr><td><strong><code>hostname</code></strong></td><td><code>String</code></td><td>Sets the domain or IP address of the proxy service.</td></tr><tr><td><strong><code>port</code></strong></td><td><code>int</code></td><td>Sets the port to be used.</td></tr></tbody></table>

## **Optional methods** <a href="#dxnbvwk3yv83" id="dxnbvwk3yv83"></a>

### `setAuthentication(String user, String password)` <a href="#uadpatdrd9lj" id="uadpatdrd9lj"></a>

Tells you the authentication parameters of your proxy if any.

<table><thead><tr><th width="216.5">Parameter</th><th>Description</th></tr></thead><tbody><tr><td><strong><code>user</code></strong></td><td>Username to be used for authentication.</td></tr><tr><td><strong><code>password</code></strong></td><td>Password to be used for authentication.</td></tr></tbody></table>

### `setProxyCertificate(@RawRes Integer proxyCertificate)` <a href="#bdayoo21qrw" id="bdayoo21qrw"></a>

If your proxy server uses a self-signed SSL certificate or one issued by a non-public Certification Authority (CA), add the CA certificate in `PEM` or `DER` format to `res/raw/` (e.g.`res/raw/proxy_certificate`) and pass as argument the file identifier (e.g.`R.raw.proxy_certificate`).

<table><thead><tr><th width="229.66666666666666">Parameter</th><th width="116">Type</th><th>Description</th></tr></thead><tbody><tr><td><strong><code>proxyCertificate</code></strong></td><td>int</td><td>ID of the proxy certificate file.</td></tr></tbody></table>

### `setMTLSConfig(@RawRes Integer clientCertificate, String password)` <a href="#aq097dv78l4y" id="aq097dv78l4y"></a>

If your proxy server supports mTLS, save the certificate to be used by the client in `PKCS12` format (`.p12`) in `res/raw/ (e.g. res/raw/client_certificate)` and pass the file identifier (e.g. R.raw\.client\_certificate) and the private key as an argument.

<table><thead><tr><th width="232">Parameter</th><th width="140.66666666666666">Type</th><th>Description</th></tr></thead><tbody><tr><td><strong><code>clientCertificate</code></strong></td><td><code>int</code></td><td>ID of the certificate file to be used by the client.</td></tr><tr><td><strong><code>password</code></strong></td><td><code>String</code></td><td>Private key to be used by the customer.</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.caf.io/caf-sdk/android/standalone-modules/document-detector/builder/advanced-settings/proxy-settings.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
